(* uiApplication.ml     Wrapper for Cocoa Touch UIApplication
 *
 * Copyright (c) 2011 Psellos   http://psellos.com
 * Licensed under the MIT license:
 *     http://www.opensource.org/licenses/mit-license.php
 *)

type sbstyle = 
    | StatusBarStyleDefault
    | StatusBarStyleBlackTranslucent
    | StatusBarStyleBlackOpaque

external _statusBarStyle : nativeint -> sbstyle =
    "UIApplication_statusBarStyle"
external _setStatusBarStyle' : nativeint -> sbstyle -> unit =
    "UIApplication_setStatusBarStyle_"

class t robjcv =
object (self)
    inherit Wrapper.t robjcv

    method statusBarStyle = _statusBarStyle self#contents
    method setStatusBarStyle' s = _setStatusBarStyle' self#contents s
end

external sharedApplication : unit -> t =
    "UIApplication_sharedApplication"

let () =
    let wrap robjcv = new t robjcv
    in
        Callback.register "UIApplication.wrap" wrap
