(* $Id: glLight.mli,v 1.7 2003/04/24 16:42:59 erickt Exp $ *)

open Gl

type fog_param = [
    `mode of [`linear|`exp|`exp2]
  | `density of float
  | `start of float
  | `End of float
  | `color of rgba
]
val fog : fog_param -> unit

type light_param = [
    `ambient of rgba
  | `diffuse of rgba
  | `specular of rgba
  | `position of point4
  | `spot_direction of point3
  | `spot_exponent of float
  | `spot_cutoff of float
  | `constant_attenuation of float
  | `linear_attenuation of float
  | `quadratic_attenuation of float
]
val light : num:int -> light_param -> unit

val light_model : [
    `ambient of rgba
  | `two_side of bool
] -> unit

type material_param = [
    `ambient of rgba
  | `diffuse of rgba
  | `specular of rgba
  | `emission of rgba
  | `shininess of float
  | `ambient_and_diffuse of rgba
]
val material : face:face -> material_param -> unit
