(* $Id: glMisc.ml,v 1.8 2008/10/25 02:22:58 garrigue Exp $ *)

open StdLabels

external get_string : [`vendor|`renderer|`version|`extensions] -> string
    = "ml_glGetString"

let rec check_substring ~sep ~start ~buf s =
  let len = String.length s in
  if String.length buf < len + start then false else
  if String.sub buf ~pos:start ~len = s &&
    (String.length buf = len + start || buf.[len+start] = sep) then true
  else match
    try Some (String.index_from buf start sep) with Not_found -> None
  with
  | None -> false
  | Some n -> check_substring ~sep ~start:(n+1) ~buf s

let check_extension s =
  check_substring ~sep:' ' ~start:0 ~buf:(get_string `extensions) s

type equation = float * float * float * float
external clip_plane : plane:int -> equation -> unit
    = "ml_glClipPlanef"
let clip_plane ~plane equation =
  if plane < 0 or plane > 5 then invalid_arg "Gl.clip_plane";
  clip_plane ~plane equation

type hint_target =
    [`fog|`line_smooth|`perspective_correction|`point_smooth|`generate_mipmap]
external hint : hint_target -> [`fastest|`nicest|`dont_care] -> unit
    = "ml_glHint"

external scissor : x:int -> y:int -> width:int -> height:int -> unit
  = "ml_glScissor"
